using System;
using System.IO;
using System.Runtime.InteropServices;
using System.Windows.Forms;
namespace CompileTimeTest
{
    public class WindowWrapper : IWin32Window
    {
        public WindowWrapper(Int32 handle)
        {
            _hwnd = handle;
        }

        public IntPtr Handle
        {
            get {return (IntPtr) _hwnd;}
        }

        private readonly Int32 _hwnd;
    }

    [ComVisible(true), GuidAttribute("9C7B484A-EFE1-45B2-ADE6-042601741914")]
    public class Ide
    {
        const string TestString = "SampleStatus";
        public string ModuleFolder {get; set;}
        public int DesignTimeEdit(uint window, string state, ref string newState, bool displayDialog)
        {
            if(displayDialog)
            {
                DialogResult res = MessageBox.Show("Test");
                if(res == DialogResult.Cancel)
                {
                    return -1;
                }
                return TestString.Length;
            }
            newState = TestString;
            return 0;
        }

        public int DesignTimeText(string state, ref string text)
        {
            if(string.IsNullOrEmpty(text))
            {
                return "Text".Length;
            }
            text = "Text";
            return 0;
        }

        public void AboutPlugIn(Int32 window)
        {
            MessageBox.Show(new WindowWrapper(window), "An InstallAware plug-in");
        }

        public bool CompileTimeBuild(Int32 MSIHandle, string State, string BuildPath, bool Build, ref string  Fetch)
        {
            //  This function is called during Compile Time
            //  MSIHandle: Handle to MSI file being built
            //  State: State of plug-in controls, as provided to the IDE previously
            //  BuildPath: Output folder for build that plug-in should use
            //  Build: Whether any plug-in and/or support files should actually be copied
            //  Fetch: Whether plug-in will require any files in addition to the runtime DLL
            // this must be a string value of "True" or "1" for true or "false" or "1" for false.
            //  Return: Set to TRUE if compile succeeds, FALSE if it fails
            //  See help for details

            MessageBox.Show("We are in the net assembly.\nCompileTimeBuild(\nState = \"" + State + "\"\nBuildPath = \"" + BuildPath + "\"\nBuild = " + Build + "\n\n\nModuleFolder  = \"" + ModuleFolder+"\"");
            Fetch = "True";
            if (Build)
            {
                string[] fileNames = new string[]
                    {
                        "CompileTimeTest.dll",
                        "DemoLib.dll",
                        "DesignTime_NetBridge.dll",
                        "DesignTime_NetBridge.ini",
                        "RunTime_NetBridge.dll",
                        "RunTime_NetBridge.ini",
                        "RunTimeNetBridge_debug.dll",
                        "RunTimeNetBridge_debug.ini",
                    };
                foreach(string fileName in fileNames)
                {
                    string src_path = ModuleFolder + fileName;
                    string dest_path = BuildPath + fileName;
                    // Copy the file., overwrite if it exists
                    //MessageBox.Show("Copying " + src_path + " to " + dest_path);
                    File.Copy(src_path, dest_path, true);
                }
            }
            return true;
        }


    }

}
